using UnityEditor;
using UnityEngine;

namespace AssetGraph.Core
{
    [CustomEditor(typeof(AssetGraphData))]
    public class AssetGraphDataEditor : UnityEditor.Editor
    {
        public override void OnInspectorGUI()
        {
            var assetGraphData = (AssetGraphData)target;

            DrawButton("Open", () => AssetGraphEditorWindow.Open(assetGraphData));
            DrawButton("Calculate Dependency Graph",
                () =>
                {
                    assetGraphData.runOrder =
                        assetGraphData.GetExecutionOrder(assetGraphData.Nodes, assetGraphData.Connections, true);
                });
            DrawButton("Run Graph", assetGraphData.RunGraph);
        }

        private void DrawButton(string label, System.Action action)
        {
            if (GUILayout.Button(label))
            {
                action?.Invoke();
            }
        }
    }
}